=== debian/changelog ===
modules (4.3.1-1) unstable; urgency=medium

  * New upstream release
  * Fixed upstream: lib-compile-error.patch

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 24 Sep 2019 11:29:20 +0100
