## modules 4.4.0

=== Makefile ===
--- 
+++ 
@@ -148,10 +148,16 @@
   setlibtclenvmodules := \#
 endif
 
+ifneq ($(pageropts),)
+  pagercmd := $(pager) $(pageropts)
+else
+  pagercmd := $(pager)
+endif
+
 ifeq ($(color),y)
-  setcolor := 1
-else
-  setcolor := 0
+  setcolor := auto
+else
+  setcolor := never
 endif
 
 ifeq ($(autohandling),y)
@@ -170,6 +176,18 @@
   setimplicitdefault := 1
 else
   setimplicitdefault := 0
+endif
+
+ifeq ($(extendeddefault),y)
+  setextendeddefault := 1
+else
+  setextendeddefault := 0
+endif
+
+ifeq ($(advversspec),y)
+  setadvversspec := 1
+else
+  setadvversspec := 0
 endif
 
 ifeq ($(setshellstartup),y)
@@ -192,11 +210,11 @@
 	-e 's|@initdir@|$(initdir)|g' \
 	-e 's|@etcdir@|$(etcdir)|g' \
 	-e 's|@modulefilesdir@|$(modulefilesdir)|g' \
+	-e 's|@moduleshome@|$(moduleshome)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
 	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' \
-	-e 's|@pager@|$(pager)|g' \
-	-e 's|@pageropts@|$(pageropts)|g' \
+	-e 's|@pagercmd@|$(pagercmd)|g' \
 	-e 's|@verbosity@|$(verbosity)|g' \
 	-e 's|@color@|$(setcolor)|g' \
 	-e 's|@darkbgcolors@|$(darkbgcolors)|g' \
@@ -205,8 +223,11 @@
 	-e 's|@lockedconfigs@|$(lockedconfigs)|g' \
 	-e 's|@unloadmatchorder@|$(unloadmatchorder)|g' \
 	-e 's|@implicitdefault@|$(setimplicitdefault)|g' \
+	-e 's|@extendeddefault@|$(setextendeddefault)|g' \
+	-e 's|@advversspec@|$(setadvversspec)|g' \
 	-e 's|@searchmatch@|$(searchmatch)|g' \
 	-e 's|@wa277@|$(setwa277)|g' \
+	-e 's|@icase@|$(icase)|g' \
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
@@ -383,14 +404,3 @@
 	@echo "WARNING: Documentation not built nor installed"
 endif
 	@echo
-	@echo "NOTICE: Modules installation is complete."
-	@echo "        Please read the 'Configuration' section in INSTALL.txt to learn"
-	@echo "        how to adapt your installation and make it fit your needs." >&2
-	@echo
-
-uninstall:
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd.tcl
-ifeq ($(compatversion),y)
-	rm -f $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-endif
-ifeq ($(libtclenvmodules),y)
