=== debian/changelog ===
modules (4.4.0-1) unstable; urgency=medium

  * New upsteam release
  * Standards-Version: 4.4.1.0

 -- Alastair McKinstry <mckinstry@debian.org>  Fri, 22 Nov 2019 08:59:51 +0000
