## modules 4.4.1

=== Makefile ===
--- 
+++ 
@@ -279,7 +279,15 @@
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mb: contrib/mb.in version.inc
+contrib/mb: contrib/mb.in version.inc contrib/mlprof
+	$(translate-in-script)
+	chmod +x $@
+
+contrib/mlprof: contrib/mlprof.in version.inc
+	$(translate-in-script)
+	chmod +x $@
+
+contrib/playdemo: contrib/playdemo.in version.inc
 	$(translate-in-script)
 	chmod +x $@
 
@@ -396,11 +404,3 @@
 	cp  contrib/vim/ftplugin/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftplugin
 	cp  contrib/vim/syntax/modulefile.vim    $(DESTDIR)$(vimdatadir)/syntax
 endif
-	$(MAKE) -C init install DESTDIR=$(DESTDIR)
-ifeq ($(builddoc),y)
-	$(MAKE) -C doc install DESTDIR=$(DESTDIR)
-else
-	@echo
-	@echo "WARNING: Documentation not built nor installed"
-endif
-	@echo
