=== debian/changelog ===
modules (4.4.1-1) unstable; urgency=medium

  * New upstream release
  * Specify location of pager=/usr/bin/less

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 09 Jan 2020 13:02:22 +0000
