=== debian/rules ===
--- 
+++ 
@@ -31,8 +31,8 @@
 		--with-module-path=/usr/share/modules/modulefiles \
 		--with-tcl-ver=8.6 \
 		--with-tclsh=tclsh8.6 \
+		--enable-logging \
 		--with-pager=/usr/bin/less \
-		--enable-logging \
 		--bindir=/usr/bin #LDFLAGS='$(LDFLAGS) -Wl,--as-needed' CFLAGS='$(CFLAGS) '
 
 override_dh_auto_test:
