## modules 4.5.0

=== Makefile ===
--- 
+++ 
@@ -2,14 +2,18 @@
 	install-testsiteconfig-1 install-testmodulerc install-testmodulerc-1 \
 	install-testinitrc install-testetcrc install-testmodspath \
 	install-testmodspath-empty uninstall-testconfig uninstall dist dist-tar \
-	dist-gzip dist-bzip2 srpm clean distclean test testinstall testsyntax
+	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test testinstall \
+	testsyntax
+
+# download command and its options
+WGET := wget --timeout=5 --tries=2
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_DLSRC2 := https://ftp.openbsd.org/pub/OpenBSD/distfiles/
-NAGELFAR_RELEASE := nagelfar125
+NAGELFAR_DLSRC2 := https://osdn.net/projects/sfnet_nagelfar/downloads/Rel_131/
+NAGELFAR_RELEASE := nagelfar131
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
-NAGELFAR_DISTSUM := 707e3c305437dce1f14103f0bd058fc9
+NAGELFAR_DISTSUM := fbf79ab1a1d85349600f2502a3353bf4
 NAGELFAR := $(NAGELFAR_RELEASE)/nagelfar.tcl
 
 # definition for old Tcl interpreter for coverage testing
@@ -23,8 +27,8 @@
 MODULECMDTEST := modulecmd-test.tcl
 
 # definitions for enhanced diff tool (to review test results)
-ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.2/
-ICDIFF_CHECKSUM := 2bf052d9dfb0a46af581fc390c47774a
+ICDIFF_DLSRC := https://raw.githubusercontent.com/jeffkaufman/icdiff/release-1.9.5/
+ICDIFF_CHECKSUM := fd5825ede4c2853ba1747a8931b077c1
 
 # compatibility version-related files
 COMPAT_DIR := compat
@@ -35,8 +39,8 @@
 endif
 include Makefile.inc
 
-INSTALL_PREREQ := modulecmd.tcl ChangeLog README contrib/scripts/add.modules \
-	contrib/scripts/modulecmd
+INSTALL_PREREQ := modulecmd.tcl ChangeLog README script/add.modules \
+	script/createmodule.py script/modulecmd
 TEST_PREREQ := $(MODULECMDTEST)
 
 ifeq ($(compatversion),y)
@@ -63,10 +67,17 @@
 TEST_PREREQ += tclsh83
 endif
 
+# define rule prereq when target need to be rebuilt when git repository change
+ifeq ($(wildcard .git),.git)
+GIT_REFRESH_PREREQ := .git/index
+else
+GIT_REFRESH_PREREQ := 
+endif
+
 all: initdir $(INSTALL_PREREQ)
 
 # skip doc build if no sphinx-build
-ifeq ($(builddoc),y)
+ifneq ($(builddoc),n)
 all: pkgdoc
 endif
 
@@ -95,6 +106,37 @@
 MODULES_BUILD := +$(GIT_CURRENT_BRANCH)$(subst $(GIT_CURRENT_TAG),,$(GIT_CURRENT_DESC))
 endif
 
+else
+# load raw version information
+include version.inc.in
+
+# build short date from full date found in raw data
+ifeq ($(MODULES_BUILD_FDATE),$$Format:%ci$$)
+MODULES_BUILD_DATE := $(shell date '+%Y-%m-%d')
+else
+MODULES_BUILD_DATE := $(firstword $(MODULES_BUILD_FDATE))
+endif
+
+# set a recognizable build number if one found in version.inc.in is raw data
+ifeq ($(MODULES_BUILD_HASH),$$Format:%h$$)
+MODULES_BUILD := +XX-gffffffff
+# or compute it from these information as if working from git repository
+else
+comma := ,
+MODULES_BUILD_REFS := $(subst $(comma),,$(MODULES_BUILD_REFS))
+
+ifeq ($(filter v$(MODULES_RELEASE),$(MODULES_BUILD_REFS)),v$(MODULES_RELEASE))
+MODULES_BUILD :=
+else ifeq ($(filter master,$(MODULES_BUILD_REFS)),master)
+MODULES_BUILD := +XX-g$(MODULES_BUILD_HASH)
+else ifeq ($(MODULES_BUILD_REFS),%D)
+MODULES_BUILD := +XX-g$(MODULES_BUILD_HASH)
+else
+MODULES_BUILD := +$(lastword $(MODULES_BUILD_REFS))-XX-g$(MODULES_BUILD_HASH)
+endif
+endif
+endif
+
 # determine RPM release
 # use last release if we currently sat on tag, append build number to it elsewhere
 MODULES_LAST_RPM_VERSREL := $(shell sed -n '/^%changelog/ {n;s/^\*.* - //p;q;}' \
@@ -102,14 +144,6 @@
 MODULES_LAST_RPM_RELEASE := $(lastword $(subst -, ,$(MODULES_LAST_RPM_VERSREL)))
 MODULES_RPM_RELEASE := $(MODULES_LAST_RPM_RELEASE)$(subst +,.,$(subst -,.,$(MODULES_BUILD)))
 
-else
-# source version definitions shared across the Makefiles of this project
-ifneq ($(wildcard version.inc),version.inc)
-  $(error version.inc is missing)
-endif
-include version.inc
-endif
-
 # define init configs location
 ifeq ($(initconfin),etcdir)
   modulespath := $(etcdir)/modulespath
@@ -188,6 +222,12 @@
   setadvversspec := 1
 else
   setadvversspec := 0
+endif
+
+ifeq ($(ml),y)
+  setml := 1
+else
+  setml := 0
 endif
 
 ifeq ($(setshellstartup),y)
@@ -214,6 +254,7 @@
 	-e 's|@VERSION@|$(VERSION)|g' \
 	-e 's|@TCLSHDIR@/tclsh|$(TCLSH)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' \
+	-e 's|@PYTHON@|$(PYTHON)|g' \
 	-e 's|@pagercmd@|$(pagercmd)|g' \
 	-e 's|@verbosity@|$(verbosity)|g' \
 	-e 's|@color@|$(setcolor)|g' \
@@ -231,6 +272,7 @@
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
+	-e 's|@ml@|$(setml)|g' \
 	-e 's|@setshellstartup@|$(setsetshellstartup)|g' \
 	-e 's|@quarantinesupport@|$(setquarantinesupport)|g' \
 	-e 's|@notquarantinesupport@|$(setnotquarantinesupport)|g' \
@@ -244,58 +286,52 @@
 	-e 's|@MODULES_BUILD_DATE@|$(MODULES_BUILD_DATE)|g' $< > $@
 endef
 
-ifeq ($(wildcard .git) $(wildcard version.inc.in),.git version.inc.in)
-# rebuild if git repository changed
-version.inc: version.inc.in .git/index
-	$(translate-in-script)
-
-contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in .git/index
-	$(translate-in-script)
-
-else
-# avoid shared definitions to be rebuilt by make
-version.inc: ;
-
-# do not rebuild spec file if not in git repository
-contrib/rpm/environment-modules.spec: ;
-endif
-
 DIST_PREFIX := modules-$(MODULES_RELEASE)$(MODULES_BUILD)
+DIST_WIN_PREFIX := $(DIST_PREFIX)-win
 
 # avoid shared definitions to be rebuilt by make
 Makefile.inc: ;
 
+version.inc: version.inc.in $(GIT_REFRESH_PREREQ)
+	$(translate-in-script)
+
+# source version definitions shared across the Makefiles of this project
+include version.inc
+
+contrib/rpm/environment-modules.spec: contrib/rpm/environment-modules.spec.in $(GIT_REFRESH_PREREQ)
+	$(translate-in-script)
+
 modulecmd.tcl: modulecmd.tcl.in version.inc
 	$(translate-in-script)
 	chmod +x $@
 
+# generate an empty changelog file if not working from git repository
+ifeq ($(wildcard .git),.git)
+ChangeLog: script/gitlog2changelog.py
+	script/gitlog2changelog.py
+else
 ChangeLog:
-	contrib/gitlog2changelog.py
+	echo "Please refer to the NEWS document to learn about main changes" >$@
+endif
 
 README:
 	sed -e '/^\[\!\[.*\].*/d' $@.md > $@
 
-contrib/mtreview: contrib/mtreview.in version.inc
+script/add.modules: script/add.modules.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mb: contrib/mb.in version.inc contrib/mlprof
+script/createmodule.py: script/createmodule.py.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/mlprof: contrib/mlprof.in version.inc
+script/gitlog2changelog.py: script/gitlog2changelog.py.in
 	$(translate-in-script)
 	chmod +x $@
 
-contrib/playdemo: contrib/playdemo.in version.inc
+script/modulecmd: script/modulecmd.in
 	$(translate-in-script)
 	chmod +x $@
-
-contrib/scripts/add.modules: contrib/scripts/add.modules.in
-	$(translate-in-script)
-
-contrib/scripts/modulecmd: contrib/scripts/modulecmd.in
-	$(translate-in-script)
 
 # compatibility version-related rules
 $(COMPAT_DIR)/modulecmd$(EXEEXT) $(COMPAT_DIR)/ChangeLog:
@@ -375,32 +411,6 @@
 	cp lib/libtclenvmodules$(SHLIB_SUFFIX) $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
 	chmod +x $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
 endif
-	cp contrib/envml $(DESTDIR)$(bindir)/
+	cp script/envml $(DESTDIR)$(bindir)/
 	chmod +x $(DESTDIR)$(bindir)/envml
-	cp contrib/scripts/add.modules $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/add.modules
-	cp contrib/scripts/modulecmd $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/modulecmd
-	cp contrib/scripts/mkroot $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/mkroot
-ifneq ($(wildcard $(DESTDIR)$(etcdir)/siteconfig.tcl),$(DESTDIR)$(etcdir)/siteconfig.tcl)
-	cp siteconfig.tcl $(DESTDIR)$(etcdir)/siteconfig.tcl
-endif
-ifeq ($(docinstall),y)
-	mkdir -p $(DESTDIR)$(docdir)
-	cp COPYING.GPLv2 $(DESTDIR)$(docdir)/
-	cp ChangeLog $(DESTDIR)$(docdir)/
-	cp README $(DESTDIR)$(docdir)/
-ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/ChangeLog $(DESTDIR)$(docdir)/ChangeLog-compat
-	cp $(COMPAT_DIR)/NEWS $(DESTDIR)$(docdir)/NEWS-compat
-endif
-endif
-ifeq ($(vimaddons),y)
-	mkdir -p $(DESTDIR)$(vimdatadir)/ftdetect
-	mkdir -p $(DESTDIR)$(vimdatadir)/ftplugin
-	mkdir -p $(DESTDIR)$(vimdatadir)/syntax
-	cp  contrib/vim/ftdetect/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftdetect
-	cp  contrib/vim/ftplugin/modulefile.vim  $(DESTDIR)$(vimdatadir)/ftplugin
-	cp  contrib/vim/syntax/modulefile.vim    $(DESTDIR)$(vimdatadir)/syntax
-endif
+	cp script/add.modules $(DESTDIR)$(bindir)/
