=== debian/changelog ===
modules (4.5.0-1) unstable; urgency=medium

  * New upstream release
  * Standards-Version: 4.5.0
  * Depend on python3 as python3 createmodules script included

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 14 Apr 2020 14:56:07 +0100
