=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: devel
 Priority: optional
 Maintainer: Alastair McKinstry <mckinstry@debian.org>
-Standards-Version: 4.4.1.0
+Standards-Version: 4.5.0
 Homepage: http://modules.sourceforge.net/
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
@@ -16,7 +16,7 @@
 Package: environment-modules
 Architecture: any
 Depends: tcl8.6, ${misc:Depends}, ${shlibs:Depends},
- less, procps
+ less, procps, python3
 Conflicts: lmod
 Description: Modular system for handling environment variables
  The Modules package provides for the dynamic modification of a user's
