## modules 4.5.1

=== debian/changelog ===
modules (4.5.1-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sat, 06 Jun 2020 17:47:59 +0100
