## modules 4.5.2

=== debian/changelog ===
modules (4.5.2-1) unstable; urgency=medium

  * New upstream release
  * Move to debhelper level 13
  * configure.patch: Add back previously-ignored parameters

 -- Alastair McKinstry <mckinstry@debian.org>  Tue, 04 Aug 2020 09:38:06 +0100
