## modules 4.6.0

=== Makefile ===
--- 
+++ 
@@ -2,15 +2,14 @@
 	install-testsiteconfig-1 install-testmodulerc install-testmodulerc-1 \
 	install-testinitrc install-testetcrc install-testmodspath \
 	install-testmodspath-empty uninstall-testconfig uninstall dist dist-tar \
-	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test testinstall \
-	testsyntax
+	dist-gzip dist-bzip2 dist-win srpm rpm clean distclean test-deps test \
+	testinstall testsyntax
 
 # download command and its options
-WGET := wget --timeout=5 --tries=2
+WGET := wget --retry-connrefused --waitretry=20 --timeout=20 --tries=3
 
 # definitions for code coverage
 NAGELFAR_DLSRC1 := http://downloads.sourceforge.net/nagelfar/
-NAGELFAR_DLSRC2 := https://osdn.net/projects/sfnet_nagelfar/downloads/Rel_131/
 NAGELFAR_RELEASE := nagelfar131
 NAGELFAR_DIST := $(NAGELFAR_RELEASE).tar.gz
 NAGELFAR_DISTSUM := fbf79ab1a1d85349600f2502a3353bf4
@@ -54,7 +53,12 @@
 INSTALL_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
 TEST_PREREQ += lib/libtclenvmodules$(SHLIB_SUFFIX)
 ifeq ($(COVERAGE),y)
-TEST_PREREQ += lib/libtestutil-closedir$(SHLIB_SUFFIX)
+TEST_PREREQ += lib/libtestutil-closedir$(SHLIB_SUFFIX) \
+	lib/libtestutil-getpwuid$(SHLIB_SUFFIX) \
+	lib/libtestutil-getgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-0getgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX) \
+	lib/libtestutil-getgrgid$(SHLIB_SUFFIX)
 endif
 endif
 
@@ -182,6 +186,16 @@
   setlibtclenvmodules := \#
 endif
 
+ifeq ($(multilibsupport),y)
+  setmultilibsupport :=
+  setnotmultilibsupport := \#
+  sedexprlibdir := -e 's|@libdir64@|$(libdir64)|g' -e 's|@libdir32@|$(libdir32)|g'
+else
+  setmultilibsupport := \#
+  setnotmultilibsupport :=
+  sedexprlibdir := -e 's|@libdir@|$(libdir)|g'
+endif
+
 ifneq ($(pageropts),)
   pagercmd := $(pager) $(pageropts)
 else
@@ -245,7 +259,7 @@
 define translate-in-script
 sed -e 's|@prefix@|$(prefix)|g' \
 	-e 's|@baseprefix@|$(baseprefix)|g' \
-	-e 's|@libdir@|$(libdir)|g' \
+	$(sedexprlibdir) \
 	-e 's|@libexecdir@|$(libexecdir)|g' \
 	-e 's|@initdir@|$(initdir)|g' \
 	-e 's|@etcdir@|$(etcdir)|g' \
@@ -269,6 +283,7 @@
 	-e 's|@searchmatch@|$(searchmatch)|g' \
 	-e 's|@wa277@|$(setwa277)|g' \
 	-e 's|@icase@|$(icase)|g' \
+	-e 's|@nearlyforbiddendays@|$(nearlyforbiddendays)|g' \
 	-e 's|@autohandling@|$(setautohandling)|g' \
 	-e 's|@availindepth@|$(setavailindepth)|g' \
 	-e 's|@silentshdbgsupport@|$(setsilentshdbgsupport)|g' \
@@ -278,6 +293,8 @@
 	-e 's|@notquarantinesupport@|$(setnotquarantinesupport)|g' \
 	-e 's|@libtclenvmodules@|$(setlibtclenvmodules)|g' \
 	-e 's|@SHLIB_SUFFIX@|$(SHLIB_SUFFIX)|g' \
+	-e 's|@multilibsupport@|$(setmultilibsupport)|g' \
+	-e 's|@notmultilibsupport@|$(setnotmultilibsupport)|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@NOTVERSIONING@|$(setnotversioning)|g' \
 	-e 's|@MODULES_RELEASE@|$(MODULES_RELEASE)|g' \
@@ -315,7 +332,7 @@
 endif
 
 README:
-	sed -e '/^\[\!\[.*\].*/d' $@.md > $@
+	sed -e '1,9d' $@.md > $@
 
 script/add.modules: script/add.modules.in
 	$(translate-in-script)
@@ -344,6 +361,21 @@
 lib/libtestutil-closedir$(SHLIB_SUFFIX):
 	$(MAKE) -C lib $(@F)
 
+lib/libtestutil-getpwuid$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-getgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-0getgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-getgrgid$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
 	$(translate-in-script)
@@ -389,28 +421,3 @@
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
 	cp $^ $(DESTDIR)$(modulespath)
 
-uninstall-testconfig:
-	rm -f $(DESTDIR)$(etcdir)/rc
-	rm -f $(DESTDIR)$(etcdir)/siteconfig.tcl
-	rm -f $(DESTDIR)$(initrc)
-	rm -f $(DESTDIR)$(modulespath)
-	$(MAKE) -C init uninstall-testconfig DESTDIR=$(DESTDIR)
-
-install: $(INSTALL_PREREQ)
-	mkdir -p $(DESTDIR)$(libexecdir)
-	mkdir -p $(DESTDIR)$(bindir)
-	mkdir -p $(DESTDIR)$(etcdir)
-	cp modulecmd.tcl $(DESTDIR)$(libexecdir)/
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd.tcl
-ifeq ($(compatversion),y)
-	cp $(COMPAT_DIR)/modulecmd$(EXEEXT) $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-	chmod +x $(DESTDIR)$(libexecdir)/modulecmd-compat$(EXEEXT)
-endif
-ifeq ($(libtclenvmodules),y)
-	mkdir -p $(DESTDIR)$(libdir)
-	cp lib/libtclenvmodules$(SHLIB_SUFFIX) $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
-	chmod +x $(DESTDIR)$(libdir)/libtclenvmodules$(SHLIB_SUFFIX)
-endif
-	cp script/envml $(DESTDIR)$(bindir)/
-	chmod +x $(DESTDIR)$(bindir)/envml
-	cp script/add.modules $(DESTDIR)$(bindir)/
