=== debian/changelog ===
modules (4.6.0-1) unstable; urgency=medium

  * New upstream release

 -- Alastair McKinstry <mckinstry@debian.org>  Sun, 20 Sep 2020 09:32:34 +0100

modules (4.5.3-1) unstable; urgency=medium

  * New upstream release
  * Add d/gbp.conf to match new DEP-14 git branch names

 -- Alastair McKinstry <mckinstry@debian.org>  Thu, 03 Sep 2020 08:36:50 +0100
