## modules 4.6.1

=== Makefile ===
--- 
+++ 
@@ -58,7 +58,9 @@
 	lib/libtestutil-getgroups$(SHLIB_SUFFIX) \
 	lib/libtestutil-0getgroups$(SHLIB_SUFFIX) \
 	lib/libtestutil-dupgetgroups$(SHLIB_SUFFIX) \
-	lib/libtestutil-getgrgid$(SHLIB_SUFFIX)
+	lib/libtestutil-getgrgid$(SHLIB_SUFFIX) \
+	lib/libtestutil-time$(SHLIB_SUFFIX) \
+	lib/libtestutil-mktime$(SHLIB_SUFFIX)
 endif
 endif
 
@@ -376,6 +378,12 @@
 lib/libtestutil-getgrgid$(SHLIB_SUFFIX):
 	$(MAKE) -C lib $(@F)
 
+lib/libtestutil-time$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
+lib/libtestutil-mktime$(SHLIB_SUFFIX):
+	$(MAKE) -C lib $(@F)
+
 # example configs for test rules
 testsuite/example/.modulespath: testsuite/example/.modulespath.in
 	$(translate-in-script)
@@ -415,9 +423,3 @@
 
 install-testmodspath: testsuite/example/.modulespath
 	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
-	cp $^ $(DESTDIR)$(modulespath)
-
-install-testmodspath-empty: testsuite/example/.modulespath-empty
-	$(MAKE) -C init install-testconfig DESTDIR=$(DESTDIR)
-	cp $^ $(DESTDIR)$(modulespath)
-
