=== init/Makefile ===
--- 
+++ 
@@ -1,4 +1,5 @@
-.PHONY: install install-testconfig uninstall-testconfig uninstall clean
+.PHONY: dist-win install install-testconfig uninstall-testconfig uninstall \
+	clean
 
 SH_LIKE  = sh ksh bash zsh profile.sh bash_completion
 CSH_LIKE = csh tcsh tcsh_completion profile.csh
@@ -7,6 +8,7 @@
 # example modulefiles to install
 EXAMPLE_MODFILES_SRCDIR := ../contrib/modulefiles
 EXAMPLE_MODFILES = dot module-git module-info modules null use.own
+EXAMPLE_WIN_MODFILES = module-git module-info null
 EXAMPLE_TESTCONFIG_MODFILES = null
 
 # source definitions shared across the Makefiles of this project
@@ -33,7 +35,7 @@
 
 ALL_SHELLS = $(SH_LIKE) $(CSH_LIKE) $(OTHER)
 
-all: $(ALL_SHELLS) modulerc $(EXAMPLE_MODFILES_SRCDIR)/modules
+all: $(ALL_SHELLS) modulerc zsh-functions/_module $(EXAMPLE_MODFILES_SRCDIR)/modules
 ifeq ($(versioning),y)
 all: $(EXAMPLE_MODFILES_SRCDIR)/version
 endif
@@ -160,6 +162,7 @@
 	-e 's|@SHELLNAME@|$@|g' \
 	-e 's|@VERSIONING@|$(setversioning)|g' \
 	-e 's|@VERSION@|$(VERSION)|g' \
+	-e 's|@SED_ERE@|$(SED_ERE)|g' \
 	-e 's|@PS@|$(PS)|g' \
 	-e 's|@BASENAME@|$(BASENAME)|g' \
 	-e 's|@TCLSH@|$(TCLSH)|g' $< > $@
@@ -195,6 +198,12 @@
 
 $(EXAMPLE_MODFILES_SRCDIR)/version: $(EXAMPLE_MODFILES_SRCDIR)/version.in ../version.inc
 	$(translate-in-script)
+
+dist-win:
+	mkdir $(DIST_WIN_PREFIX)/init
+	cp cmd.cmd $(DIST_WIN_PREFIX)/init/
+	mkdir $(DIST_WIN_PREFIX)/modulefiles
+	cp $(addprefix $(EXAMPLE_MODFILES_SRCDIR)/,$(EXAMPLE_WIN_MODFILES)) $(DIST_WIN_PREFIX)/modulefiles/
 
 # example configs for test rules
 install-testconfig:
@@ -215,11 +224,16 @@
 install: all
 	mkdir -p $(DESTDIR)$(initdir)
 	mkdir -p $(DESTDIR)$(initdir)/ksh-functions
+	mkdir -p $(DESTDIR)$(initdir)/zsh-functions
 	mkdir -p $(DESTDIR)$(modulefilesdir)
 	cp $(ALL_SHELLS) $(DESTDIR)$(initdir)/
+ifeq ($(windowssupport),y)
+	cp cmd.cmd $(DESTDIR)$(initdir)/
+endif
 	cp fish_completion $(DESTDIR)$(initdir)/
-	cp -r zsh-functions $(DESTDIR)$(initdir)/
+	cp zsh-functions/_module $(DESTDIR)$(initdir)/zsh-functions/
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/module
+	cp ksh $(DESTDIR)$(initdir)/ksh-functions/ml
 ifeq ($(compatversion),y)
 	cp ksh $(DESTDIR)$(initdir)/ksh-functions/switchml
 else
@@ -240,7 +254,11 @@
 
 uninstall:
 	rm -f $(addprefix $(DESTDIR)$(initdir)/,$(ALL_SHELLS) fish_completion)
+ifeq ($(windowssupport),y)
+	rm -f $(DESTDIR)$(initdir)/cmd.cmd
+endif
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/module
+	rm -f $(DESTDIR)$(initdir)/ksh-functions/ml
 ifeq ($(compatversion),y)
 	rm -f $(DESTDIR)$(initdir)/ksh-functions/switchml
 endif
@@ -259,7 +277,7 @@
 endif
 
 clean:
-	rm -f $(ALL_SHELLS) modulerc .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
+	rm -f $(ALL_SHELLS) modulerc zsh-functions/_module .modulespath $(EXAMPLE_MODFILES_SRCDIR)/modules
 ifeq ($(versioning),y)
 	rm -f $(EXAMPLE_MODFILES_SRCDIR)/version
 endif
