=== debian/control ===
--- 
+++ 
@@ -7,7 +7,7 @@
 Vcs-Browser: https://salsa.debian.org:/mckinstry/modules.git
 Vcs-Git: https://salsa.debian.org:/mckinstry/modules.git
 Build-Depends: tcl8.6-dev | tcl-dev, 
-  debhelper-compat (= 12), 
+  debhelper-compat (= 13), 
   dejagnu, 
   tclx8.4-dev,
   less,
